﻿using System;
using System.Drawing;
using System.Web.Script.Serialization;

using MindFusion.Diagramming;
using MindFusion.Diagramming.WebForms;

using Image = System.Drawing.Image;
using Bitmap = System.Drawing.Bitmap;
using Graphics = System.Drawing.Graphics;


public partial class Default : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        // register custom item types, their serialization identifiers and JavaScript class names

		// this class demonstrates custom drawing in Canvas mode, see Scripts/MyShapeNode.js
        diagramView.RegisterItemType(typeof(MyShapeNode), "MyShapeNode", "MyShapeNode", 100);

		// register converters for serializing .NET items into JSON objects
        diagramView.RegisterConverters(new JavaScriptConverter[]
		{ 
            new MyShapeNodeConverter(diagramView)
		});
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // let users draw MyShapeNode objects in Canvas mode
		diagramView.CustomNodeType = typeof(MyShapeNode);

		if (!IsPostBack)
		{
			diagramView.Diagram.Nodes.Add(new MyShapeNode());
			diagramView.Diagram.Nodes.Add(new MyShapeNode { ShapeType = "type2" });
		}
    }

}