using System;
using System.Web.Script.Serialization;
using System.Xml;
using System.Collections.Generic;

using MindFusion.Diagramming;
using MindFusion.Diagramming.WebForms;


public class MyShapeNode : ShapeNode
{
    public MyShapeNode()
    {
		ShapeType = "type1";
    }

	public string ShapeType { get; set; }
}


public class MyShapeNodeConverter : ShapeNodeConverter
{
    public MyShapeNodeConverter(DiagramView view)
        : base(view)
    {
    }

    public override IEnumerable<Type> SupportedTypes
    {
        get { return new List<Type>(new Type[] { typeof(MyShapeNode) }); }
    }

    public override object Deserialize(
		IDictionary<string, object> dictionary, Type type, JavaScriptSerializer serializer)
    {
		var customNode = (MyShapeNode)base.Deserialize(dictionary, type, serializer);
		customNode.ShapeType = dictionary["ShapeType"].ToString();
		return customNode;
    }

    public override IDictionary<string, object> Serialize(
		object obj, JavaScriptSerializer serializer)
    {
		var shapeNode = obj as MyShapeNode;
		if (shapeNode == null)
			return null;

		var json = base.Serialize(obj, serializer);
		if (json == null)
			return null;

		json.Add("ShapeType", shapeNode.ShapeType);

		return json;

    }
}